package app;


import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.WindowConstants;

import org.jfree.chart.ChartPanel;


public class Prozor extends JFrame{

	// probat titled border za parametre...
	private static final long serialVersionUID = 1L;
	Prikaz p;
	PostavkeGUI pgui;
	ArrayList<Algoritam> lista_algoritama;
	Icon pause, next, play;
	final String sep = System.lineSeparator();
	boolean preskoci=false;
	State status;
	int DEFAULT=0,GO=1,PAUSE=2,NEXT=3;
	// 0-pocetak, 1-GO, 2-PAUSE, 3-NEXT
	
	public Prozor(ArrayList<Algoritam> lista_algoritama) throws ClassNotFoundException, InstantiationException, IllegalAccessException, UnsupportedLookAndFeelException {
		super();
		this.lista_algoritama=lista_algoritama;
		initGUI();

	}
	
	
	protected void initGUI() throws ClassNotFoundException, InstantiationException, IllegalAccessException, UnsupportedLookAndFeelException {
		
		UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		setSize(1200, 800);
		setTitle("APR");
		setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
		this.getContentPane().setLayout(new BorderLayout());
		
		p=new Prikaz();
		pgui=new PostavkeGUI(lista_algoritama.get(0).dajPostavke());
		
		
		JPanel cijeli = new JPanel(new BorderLayout());
		final JPanel menu = new JPanel(new BorderLayout());
		JPanel dolje = new JPanel(new BorderLayout());
		JPanel funkcPanel = new JPanel(new GridLayout(1, 2));
		JPanel algPanel = new JPanel(new GridLayout(1, 2));
		JPanel params_total = new JPanel(new BorderLayout());
		JPanel params_ispis = new JPanel(new BorderLayout());
		JPanel delaypanel = new JPanel(new GridLayout(1,2,50,150));
		JPanel kontrola = new JPanel(new GridLayout(1, 4));
		JPanel za_kontrolu = new JPanel(new BorderLayout());
		
		JLabel fjalabel = new JLabel("Funkcija", SwingConstants.CENTER);
		JLabel alglabel = new JLabel("Algoritam", SwingConstants.CENTER);
		
		final JTextArea tekst = new JTextArea();
		JScrollPane scrollPane = new JScrollPane(tekst); 
		scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		tekst.setEditable(false);
		tekst.setFont(new Font("Times New Roman", Font.PLAIN, 14));
		
		String[] opcije = { "5", "2", "1", "0.5", "0.25", "0"};
		final JComboBox<String> delay = new JComboBox<String>(opcije);
		delay.setBorder(BorderFactory.createTitledBorder("Delay(sec)"));
		delay.setSelectedIndex(0);
		delay.setPreferredSize(new Dimension(80, 40));
		
		pause = new ImageIcon("data/Pause24.gif");
		next = new ImageIcon("data/StepForward24.gif");
		play = new ImageIcon("data/Play24.gif");
		
		final JButton go = new JButton(play);
		final JButton pause_button = new JButton(pause);
		final JButton stepf = new JButton(next);
		final JButton info = new JButton("INFO");
		
		info.setBackground(Color.ORANGE);
		pause_button.setEnabled(false);
		
		
		String[] primjeri = { "10*(x^2-y)^2+(1-x)^2", "(x-4)^2 + 4*(y-2)^2", "abs((x-y)*(x+y)) + (x^2+y^2)^0.5" };
		final JComboBox<String> funkcija = new JComboBox<String>(primjeri);
		funkcija.setEditable(true);
		
		String[] imena = new String[lista_algoritama.size()];
		for(int i=0;i<lista_algoritama.size();i++)
			imena[i]=lista_algoritama.get(i).getName();
		
		final JComboBox<String> algoritmi = new JComboBox<String>(imena);
		algoritmi.setSelectedIndex(0);
		
		funkcPanel.setBorder(BorderFactory.createLineBorder(Color.BLUE,2));
		algPanel.setBorder(BorderFactory.createLineBorder(Color.LIGHT_GRAY,2));
		
		
		delaypanel.add(info);
		
		
		params_ispis.add(pgui, BorderLayout.NORTH);
		params_ispis.add(scrollPane, BorderLayout.CENTER);
		
		
		params_total.add(params_ispis, BorderLayout.CENTER);
		
		
		funkcPanel.add(fjalabel);
		funkcPanel.add(funkcija);
		
		algPanel.add(alglabel);
		algPanel.add(algoritmi);
		
		
		kontrola.add(pause_button);
		kontrola.add(stepf);
		kontrola.add(go);
		za_kontrolu.add(delay, BorderLayout.WEST);
		za_kontrolu.add(kontrola, BorderLayout.EAST);
		
		dolje.add(delaypanel, BorderLayout.WEST);
		dolje.add(za_kontrolu, BorderLayout.EAST);
		
		menu.add(algPanel, BorderLayout.NORTH);
		menu.add(params_total, BorderLayout.CENTER);
		menu.add(dolje, BorderLayout.SOUTH);
		
		cijeli.add(funkcPanel, BorderLayout.NORTH);
		cijeli.add(menu, BorderLayout.CENTER);
		
		final ChartPanel cp = new ChartPanel(p.dajGraf());
		
		this.getContentPane().add(cijeli, BorderLayout.EAST);
		this.getContentPane().add(cp, BorderLayout.CENTER);
		
		this.status=new State(pause_button, stepf, go);		
		this.status.setStanje(DEFAULT);
		
		info.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				JOptionPane pane = new JOptionPane();
				String text = "Pozdrav,"+sep+sep
						+"Par informacija:"+sep
						+"Selektiranjem ili desnim klikom može se zumirati određeno područje grafa."+sep
						+"Ako želite maknuti neko implicitno ograničenje, polje samo ostavite prazno."
						+sep+sep
						+"Autor - Petar Čolić"+sep
						+"Mentor - Prof. dr. sc. Domagoj Jakobović";
				JOptionPane.showMessageDialog(pane,	text, "INFO", JOptionPane.INFORMATION_MESSAGE);
				
			}
		});
		
		
		algoritmi.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				@SuppressWarnings("unchecked")
				JComboBox<String> cb = (JComboBox<String>)e.getSource();
		        String ime = (String)cb.getSelectedItem();
		        
				for(int i=0;i<lista_algoritama.size();i++)
					if (lista_algoritama.get(i).getName().equalsIgnoreCase(ime)){
						pgui.update(lista_algoritama.get(i).dajPostavke());
						break;
					}
				menu.validate();
				menu.repaint();
				
			}
		});
		
		pause_button.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				status.setStanje(PAUSE);
				
			}
		});
		
		stepf.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				if (status.getStanje()==PAUSE || status.getStanje()==NEXT){
					synchronized (status) {
						status.setStanje(NEXT);
						status.notify();
					}
					
				}
				if (status.getStanje()==DEFAULT){
					preskoci=true;
					go.doClick();
				}
			}
		});
		
		
		go.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				
				if (status.getStanje()==PAUSE || status.getStanje()==NEXT){
					synchronized (status) {
						status.setStanje(GO);
						status.notify();
					}
				}
				else{
				if (preskoci)
					status.setStanje(NEXT);
				else
					status.setStanje(GO);
				algoritmi.setEnabled(false);
				funkcija.setEnabled(false);
				pgui.myDisable();
				final int index = algoritmi.getSelectedIndex();
				final ArrayList<String> vrijednosti = pgui.dajVrijednosti();
				
				new Thread(new Runnable() {
					
					@Override
					public void run() {
						try {
							Algoritam alg = lista_algoritama.get(index);
							
							alg.spremiPostavke(vrijednosti);
							alg.postaviFunkciju((String) funkcija.getSelectedItem());
							alg.kreni(p, tekst, delay, status);
							
						} catch (final Exception e) {
							try {
								SwingUtilities.invokeAndWait(new Runnable() {
									@Override
									public void run() {
										
										JOptionPane pane = new JOptionPane();
										JOptionPane.showMessageDialog(pane,	e.getMessage(), "Poruka sustava", JOptionPane.ERROR_MESSAGE);
										
									}
								});
							} catch (InvocationTargetException
									| InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						
							
						}
						
						
						try {
							SwingUtilities.invokeAndWait(new Runnable() {
								
								@Override
								public void run() {
									
									status.setStanje(DEFAULT);
									algoritmi.setEnabled(true);
									funkcija.setEnabled(true);
									pgui.myEnable();
									preskoci=false;
									cp.validate(); // možda maknut
									cp.repaint();
								}
							});
						} catch (InvocationTargetException
								| InterruptedException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						
						
						
					}
				}).start();
				
				}
			}
		});
		
	}

	
		
	}
